unit ArchiverMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ComCtrls, StdCtrls, ThumbnailLibCtl_TLB, AxCtrls, DbOleCtl,
  ImgeditLibCtl_TLB, OleCtrls, ScanLibCtl_TLB, ToolWin, ActnList, ImgList,
  Menus, ExtDlgs, DB, Buttons;

type
  TfrmArchiverMain = class(TForm)
    Splitter1: TSplitter;
    Panel1: TPanel;
    Panel2: TPanel;
    ImgScan: TImgScan;
    ImgEdit: TImgEdit;
    Panel3: TPanel;
    ImgThumbnail: TImgThumbnail;
    Splitter2: TSplitter;
    Panel4: TPanel;
    lvFiles: TListView;
    ToolBar1: TToolBar;
    btnScann: TToolButton;
    btnEmail: TToolButton;
    ToolButton5: TToolButton;
    ToolButton9: TToolButton;
    btnImport: TToolButton;
    ToolButton11: TToolButton;
    btnExport: TToolButton;
    ActionList1: TActionList;
    actScann: TAction;
    actImport: TAction;
    actOutlook: TAction;
    ImageList: TImageList;
    actExport: TAction;
    actSaveArchive: TAction;
    PopupMenu: TPopupMenu;
    Beolvass1: TMenuItem;
    Importls1: TMenuItem;
    Exportls1: TMenuItem;
    jkp1: TMenuItem;
    actNewImage: TAction;
    pmScanner: TPopupMenu;
    miSetupBfScann: TMenuItem;
    OpenDialog: TOpenPictureDialog;
    smallImageList: TImageList;
    Trls1: TMenuItem;
    actDelete: TAction;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    Tulajdonsgok1: TMenuItem;
    Panel5: TPanel;
    btnSave: TBitBtn;
    btnCancel: TBitBtn;
    procedure actScannExecute(Sender: TObject);
    procedure lvFilesChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure miSetupBfScannClick(Sender: TObject);
    procedure actNewImageExecute(Sender: TObject);
    procedure actImportExecute(Sender: TObject);
    procedure actOutlookExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure lvFilesDblClick(Sender: TObject);
    procedure actDeleteExecute(Sender: TObject);
    procedure actSaveArchiveExecute(Sender: TObject);
    procedure ImgThumbnailClick(Sender: TObject; ThumbNumber: Integer);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    FFileExts:TStringList;
    FArchivExist:Boolean;
    function AddIcon(AFileName:string):integer;
  end;

var
  frmArchiverMain: TfrmArchiverMain;

implementation

uses ClientMainDataModule, MailsAndFaxes, ShellApi, HuYesNoDialog,
     ArchiverMainDataModule,ZLIB;

{$R *.DFM}

procedure TfrmArchiverMain.actScannExecute(Sender: TObject);
var lvExists:boolean;
    lvFileSize:integer;
    lvName:string;
    DFS:TStream;
begin
  try
    with ImgScan do
    if ScannerAvailable then
    Begin
      if (lvFiles.SelCount=0) or (ExtractFileExt(lvFiles.Selected.Caption)<>'.tif') then
        actNewImage.Execute;
      lvName:=lvFiles.Selected.SubItems.Strings[0]+lvFiles.Selected.Caption;
      DestImageControl:=ImgEdit.Name;
      ScanTo:=1;
      ShowSetupBeforeScan:=miSetupBfScann.Checked;
      if FileExists(lvName) then
      Begin
        DFS:=TFileStream.Create(lvName,fmOpenRead);
        lvFileSize:=DFS.Size;
        FreeAndNil(DFS);
        if lvFileSize=0 then
          DeleteFile(lvName);
      End;
      lvExists:=FileExists(lvName);
      if lvExists then
        PageOption:=2
      else
        PageOption:=1;
      Image:=lvName;
      StartScan;
      if lvExists then
      with ImgThumbnail do
      Begin
        Image:=lvName;
        DisplayThumbs;
      End;
    End;
  except
    //hibakezels ide
  end;
end;

procedure TfrmArchiverMain.lvFilesChange(Sender: TObject; Item: TListItem;
  Change: TItemChange);
var lvName:string;
begin
  if (Change=ctState) and Item.Focused and Item.Selected then
  try
    lvName:=Item.SubItems.Strings[0]+Item.Caption;
    if FileExists(lvName) then
    Begin
      if ImgThumbnail.Image<>lvName then
      Begin
        with ImgThumbnail do
        Begin
          Image:=lvName;
          DisplayThumbs;
        End;
        with ImgEdit do
        Begin
          Page:=1;
          Image:=lvName;
          Display;
        End;
      End;
    End;
  except
    //ShowMessage(Exception(ExceptObject).Message);
    try
      ImgThumbnail.Image:='';
      imgEdit.ClearDisplay;
    except
    end
  end;
  if ImgThumbnail.Image='' then
    imgEdit.enabled:=false
  else
    imgEdit.enabled:=true;
end;

procedure TfrmArchiverMain.miSetupBfScannClick(Sender: TObject);
begin
  TMenuItem(Sender).Checked:=not TMenuItem(Sender).Checked;
end;

procedure TfrmArchiverMain.actNewImageExecute(Sender: TObject);
var lvName:string;
    lvListItem:TListItem;
    cv:integer;
    DFS:TStream;
begin
  cv:=0;
  lvName:='Kp'+Format('%.8d',[cv])+'.tif';
  lvListItem:=lvFiles.FindCaption(0,lvName,False,True,True);
  while (FileExists(lvName)
     or (assigned(lvListItem) and (lvListItem.SubItems.Strings[0]=dmClientMain.TempFilePath)))
    and (cv<maxint) do
  Begin
    inc(cv);
    lvName:='Kp'+Format('%.8d',[cv])+'.tif';
    lvListItem:=lvFiles.FindCaption(0,lvName,False,True,True);
  End;
  lvListItem:=lvFiles.Items.Add;
  lvListItem.Caption:=lvName;
  lvListItem.SubItems.Add(dmClientMain.TempFilePath);
  while assigned(lvFiles.Selected) do
    lvFiles.Selected.Selected:=False;
  lvListItem.Selected:=True;
  DFS:=TFileStream.Create(dmClientMain.TempFilePath+lvName,fmCreate);
  DFS.Free;
  lvListItem.ImageIndex:=AddIcon(dmClientMain.TempFilePath+lvName);
  ImgThumbnail.Image:='';
  imgEdit.ClearDisplay;
end;

procedure TfrmArchiverMain.actImportExecute(Sender: TObject);
var lvListItem:TListItem;
    cv:integer;
begin
  with OpenDialog do
  if Execute then
  for cv:=0 to Files.Count-1 do
  Begin
    lvListItem:=lvFiles.Items.Add;
    lvListItem.Caption:=ExtractFileName(Files.Strings[cv]);
    lvListItem.SubItems.Add(ExtractFilePath(Files.Strings[cv]));

    while assigned(lvFiles.Selected) do
      lvFiles.Selected.Selected:=False;
    lvListItem.Selected:=True;
    lvListItem.ImageIndex:=AddIcon(Files.Strings[cv]);
  End;
end;

procedure TfrmArchiverMain.actOutlookExecute(Sender: TObject);
begin
  frmMailsAndFaxes.actRefreshMailList.Execute;
  frmMailsAndFaxes.ShowModal;
end;

procedure TfrmArchiverMain.FormCreate(Sender: TObject);
begin
  FFileExts:=TStringList.Create;
end;

procedure TfrmArchiverMain.FormDestroy(Sender: TObject);
begin
  FFileExts.Free;
end;

procedure TfrmArchiverMain.lvFilesDblClick(Sender: TObject);
begin
  ShellExecute(Handle,'Open',PChar(lvFiles.Selected.Caption),nil,PChar(lvFiles.Selected.SubItems.Strings[0]),sw_Show);
end;

procedure TfrmArchiverMain.actDeleteExecute(Sender: TObject);
begin
  if not assigned(frmHuYesNoDialog) then
    Application.CreateForm(TfrmHuYesNoDialog,frmHuYesNoDialog);
  frmHuYesNoDialog.lbMessage.Caption:='A ttel eltvolitst kezdemnyezte.'#13#10'Krem megerstst a mvelethez.';
  if frmHuYesNoDialog.ShowModal=mrOK then
    while assigned(lvFiles.Selected) do
      lvFiles.Selected.Delete;
  ImgThumbnail.Image:='';
  imgEdit.ClearDisplay;
end;

procedure TfrmArchiverMain.actSaveArchiveExecute(Sender: TObject);
var cv:integer;
    lvListItem:TListItem;
    lvFileName:string;
    lvDestFileName:string;
    SFS,DFS:TStream;
    ZFS:TCompressionStream;
    lvWriteCount:Integer;
    lvItemSize:Integer;
begin
  if FArchivExist then
  Begin
    if not assigned(frmHuYesNoDialog) then
      Application.CreateForm(TfrmHuYesNoDialog,frmHuYesNoDialog);
    frmHuYesNoDialog.lbMessage.Caption:='Az archiv anyag ltezik.'#13#10'Kvn j verzit ltrehozni?';
    if frmHuYesNoDialog.ShowModal=mrCancel then
    Begin
      ModalResult:=mrNone;
      exit;
    End;
  End;
  try
    Screen.Cursor:=crSQLWait;
    with lvFiles do
    try
      cv:=0;
      lvDestFileName:=dmClientMain.TempFilePath+'Temp'+Format('%.8d',[cv]);
      while FileExists(lvDestFileName) and (cv<maxint) do
      Begin
        inc(cv);
        lvDestFileName:=dmClientMain.TempFilePath+'Temp'+Format('%.8d',[cv]);
      End;
      DFS:=TFileStream.Create(lvDestFileName,fmCreate);
      ZFS:=TCompressionStream.Create(clMax,DFS);
      lvWriteCount:=Items.Count;
      ZFS.WriteBuffer(lvWriteCount,sizeOf(lvWriteCount));
      for cv:=0 to Items.Count-1 do
      begin
        lvListItem:=Items.Item[cv];
        lvFileName:=lvListItem.SubItems.Strings[0]+lvListItem.Caption;
        if FileExists(lvFileName) then
        try
          SFS:=TFileStream.Create(lvFileName,fmOpenRead);

          lvItemSize:=Length(lvListItem.Caption);
          ZFS.WriteBuffer(lvItemSize,sizeOf(lvItemSize));
          ZFS.WriteBuffer(Pointer(lvListItem.Caption)^,lvItemSize);

          lvItemSize:=SFS.Size;
          ZFS.WriteBuffer(lvItemSize,sizeOf(lvItemSize));
          ZFS.CopyFrom(SFS,lvItemSize);

          FreeAndNil(SFS);
        except
          MessageDlg(Exception(ExceptObject).Message+#13#10'A file nem nyithat meg olvassra.',mtError,[mbRetry, mbCancel, mbAbort],0);
          FreeAndNil(SFS);
        end;
      end;
    finally
      FreeAndNil(ZFS);
      FreeAndNil(DFS);
    end;
    with dmArchiverMain do
    try
      dmClientMain.dsGetDocumentStoreName.Close;
      dmClientMain.dsGetDocumentStoreName.Parameters.ParamByName('@DSID').Value:=dmClientMain.dstSearchDocumentRegisterData.FieldByName('DocumentStoreID').Value;
      dmClientMain.dsGetDocumentStoreName.Open;
      cmdUseDB.CommandText:='Use ['+dmClientMain.dsGetDocumentStoreName.FieldByName('DocumentStore').Value+']';
      dmClientMain.dsGetDocumentStoreName.Close;
      cmdUseDB.Execute;
      cmdInsertArchivData.Parameters.ParamByName('@ArchivData').LoadFromFile(lvDestFileName,ftvarBytes);
      cmdInsertArchivData.Execute;
      cmdUseDB.CommandText:='Use ['+dmClientMain.MasterDatabase+']';
      cmdUseDB.Execute;
      cmdUpdateDocument.Parameters.ParamByName('@ArchivIndex').Value:=cmdInsertArchivData.Parameters.ParamByName('@ArchivIndex').Value;
      cmdUpdateDocument.Parameters.ParamByName('@DocumentID').Value:=dmClientMain.dstSearchDocumentRegisterData.FieldByName('DocumentID').Value;
      cmdUpdateDocument.Execute;
    finally
      DeleteFile(lvDestFileName);
      with lvFiles do
        for cv:=0 to Items.Count-1 do
          if Items[cv].SubItems.Strings[0]=dmClientMain.TempFilePath then
            DeleteFile(Items[cv].SubItems.Strings[0]+Items[cv].Caption);
    end
  finally
    Screen.Cursor:=crDefault;
  end
end;

function TfrmArchiverMain.AddIcon(AFileName: string): integer;
var lvExt:string;
    lvIcon:TIcon;
    lvIconIndex:Word;
begin
  lvExt:=ExtractFileExt(AFileName);
  Result:=FFileExts.IndexOf(lvExt);
  if Result=-1 then
  Begin
    Result:=FFileExts.Add(lvExt);
    lvIcon:=TIcon.Create;
    lvIconIndex:=1;
    lvIcon.Handle:=ExtractAssociatedIcon(Application.Handle,PChar(AFileName),lvIconIndex);
    smallImageList.AddIcon(lvIcon);
    lvIcon.ReleaseHandle;
    lvIcon.Free;
  End;
end;

procedure TfrmArchiverMain.ImgThumbnailClick(Sender: TObject;
  ThumbNumber: Integer);
begin
  if FileExists(ImgThumbnail.Image) then
  Begin
    ImgEdit.Enabled:=True;
    ImgEdit.Image:=ImgThumbnail.Image;
    ImgEdit.Page:=ThumbNumber;
    ImgEdit.Display;
  End;
end;

procedure TfrmArchiverMain.FormShow(Sender: TObject);
begin
  lvFiles.SetFocus;
end;

end.
