unit ClientMainDataModule;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Registry,
  ADODB, Db;

type
  TdmClientMain = class(TDataModule)
    ADOConnection: TADOConnection;
    dstSearchDocumentRegisterData: TADODataSet;
    dstSearchDocumentRegisterDataIncomingActionID: TIntegerField;
    dstSearchDocumentRegisterDataIncomingDate: TDateTimeField;
    dstSearchDocumentRegisterDataIncomingClerkID: TIntegerField;
    dstSearchDocumentRegisterDataIncomingClerkName: TWideStringField;
    dstSearchDocumentRegisterDataIncomingClerkOrganizationUnitID: TIntegerField;
    dstSearchDocumentRegisterDataIncomingClerkOrganizationUnitName: TWideStringField;
    dstSearchDocumentRegisterDataRegisterActionID: TIntegerField;
    dstSearchDocumentRegisterDataRegisterDate: TDateTimeField;
    dstSearchDocumentRegisterDataRegisterClerkID: TIntegerField;
    dstSearchDocumentRegisterDataRegisterClerkName: TWideStringField;
    dstSearchDocumentRegisterDataRegisterClerkOrganizationUnitID: TIntegerField;
    dstSearchDocumentRegisterDataRegisterClerkOrganizationUnitName: TWideStringField;
    dstSearchDocumentRegisterDataDocumentID: TAutoIncField;
    dstSearchDocumentRegisterDataDocumentTypeID: TIntegerField;
    dstSearchDocumentRegisterDataAttributes: TBytesField;
    dstSearchDocumentRegisterDataNumberOfAttachments: TIntegerField;
    dstSearchDocumentRegisterDataArchivIndex: TStringField;
    dstSearchDocumentRegisterDataDocumentIncomingID: TAutoIncField;
    dstSearchDocumentRegisterDataSubjectID: TIntegerField;
    dstSearchDocumentRegisterDataCustomerID: TIntegerField;
    dstSearchDocumentRegisterDataDocumentKindID: TIntegerField;
    dstSearchDocumentRegisterDataIncomingNumber: TIntegerField;
    dstSearchDocumentRegisterDataDocumentRegisterID: TAutoIncField;
    dstSearchDocumentRegisterDataDocumentRegisterBookID: TIntegerField;
    dstSearchDocumentRegisterDataFormatedRegisterNumber: TWideStringField;
    dstSearchDocumentRegisterDataRegisteringNumber: TIntegerField;
    dstSearchDocumentRegisterDataClerkID: TIntegerField;
    dstSearchDocumentRegisterDataReferenceNumber: TWideStringField;
    dstSearchDocumentRegisterDataSubNumber: TSmallintField;
    dstSearchDocumentRegisterDataAntecedentsDocumentID: TIntegerField;
    dstSearchDocumentRegisterDataDateOfDispatch: TDateTimeField;
    dstSearchDocumentRegisterDataDispatchMode: TWideStringField;
    dstSearchDocumentRegisterDataDispatchDate: TDateTimeField;
    dstSearchDocumentRegisterDataFilingDate: TDateTimeField;
    dstSearchDocumentRegisterDataFilingStoreName: TWideStringField;
    dstSearchDocumentRegisterDataCompanyID: TAutoIncField;
    dstSearchDocumentRegisterDataCompany: TWideStringField;
    dstSearchDocumentRegisterDataDocumentKind: TWideStringField;
    dstSearchDocumentRegisterDataDocumentType: TWideStringField;
    dstSearchDocumentRegisterDataSubject: TStringField;
    dstSearchDocumentRegisterDataFilingType: TWideStringField;
    dstSearchDocumentRegisterDataClerkName: TWideStringField;
    dstSearchDocumentRegisterDataOrganizationUnitID: TAutoIncField;
    dstSearchDocumentRegisterDataClerkOrganizationUnitName: TWideStringField;
    dstSearchDocumentRegisterDataCustomer: TWideStringField;
    dstSearchDocumentRegisterDataFilingTypeCode: TWideStringField;
    dstSearchDocumentRegisterDataIncomingDescription: TMemoField;
    dstSearchDocumentRegisterDataRegisterDescription: TMemoField;
    dstSearchDocumentRegisterDataDocumentIncomingBook: TWideStringField;
    dstSearchDocumentRegisterDataDocumentRegisterBook: TWideStringField;
    dstSearchDocumentRegisterDataFilingStoreID: TAutoIncField;
    dscSearchDocumentRegisterData: TDataSource;
    spGetDocumentValuesByID: TADOStoredProc;
    spGetDocumentTypeFields: TADOStoredProc;
    spGetDocumentTypeFieldsDocumentTypeID: TAutoIncField;
    spGetDocumentTypeFieldsDocumentType: TWideStringField;
    spGetDocumentTypeFieldsDocumentTypeFieldID: TAutoIncField;
    spGetDocumentTypeFieldsDocumentTypeField: TWideStringField;
    spGetDocumentTypeFieldsFieldTypeID: TIntegerField;
    spGetDocumentTypeFieldsFieldSize: TIntegerField;
    spGetDocumentTypeFieldsFieldPrecision: TIntegerField;
    spGetDocumentTypeFieldsFieldDescription: TWideStringField;
    spGetDocumentTypeFieldsDisplayText: TWideStringField;
    dsGetCurrentUser: TADODataSet;
    dsGetCurrentUserCurrentUser: TWideStringField;
    spGetClerkIDBySQLServerLoginName: TADOStoredProc;
    dsSearch: TADODataSet;
    dscSearch: TDataSource;
    dstSearchDocumentRegisterDataDocumentStoreID: TIntegerField;
    dsGetDocumentStoreName: TADODataSet;
    procedure DataModuleCreate(Sender: TObject);
    procedure dsSearchAfterScroll(DataSet: TDataSet);
    procedure dstSearchDocumentRegisterDataAfterScroll(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
    ClientMachineReg:TRegistry;

    CurrentOrganizationUnitID,
    CurrentClerkID:integer;

    UseIntegratedSecurity:Boolean;

    ConnectionString,
    SQLServerName,
    MasterDatabase,
    ClientRootFolder,
    TempFilePath,
    WorkstationName,
    CurrentClerkSQLServerLoginName:string;



    procedure ReloadRegistry;
    procedure Authentication;
  end;

var
  dmClientMain: TdmClientMain;

implementation
uses ServerConsts, ClientConsts, SearchList, ClientMain;
{$R *.DFM}

procedure TdmClientMain.DataModuleCreate(Sender: TObject);
begin
  ReloadRegistry;
end;

procedure TdmClientMain.Authentication;
const LoginFailed:string='Belps sikertelen. A felhasznlhoz rvnyes kiszolgl szksges.'#13#10'Jelenlegi bellts:(%s) rvnytelen.'#13#10;
var trycount:integer;
begin
  if UseIntegratedSecurity then
    ADOConnection.LoginPrompt:=false
  else
    ADOConnection.LoginPrompt:=true;

  ADOConnection.Connected:=false;
  ADOConnection.ConnectionString:=ConnectionString;
  trycount:=1;
  while (trycount<4) and not ADOConnection.Connected do
  try
    ADOConnection.Connected:=true;
  except
    On E:Exception do
    Begin
      Assert(E.Message<>'A felhasznl megszaktotta a mveletet');
      if trycount=3 then
        raise EPrivilege.Create(Format(LoginFailed,[SQLServerName+'/'+MasterDatabase+' </'+CurrentClerkSQLServerLoginName+'/>']))
      else
        inc(trycount);
    End;
  end;

  if not UseIntegratedSecurity then
  begin
    dsGetCurrentUser.Open;
    CurrentClerkSQLServerLoginName:=
      dsGetCurrentUser.FieldByName('CurrentUser').Value;
    dsGetCurrentUser.Close;
  end;
  spGetClerkIDBySQLServerLoginName.Parameters.
      ParamByName('@SQLServerLoginName').Value:=
        CurrentClerkSQLServerLoginName;
  spGetClerkIDBySQLServerLoginName.ExecProc();
  if (spGetClerkIDBySQLServerLoginName.Parameters.
    ParamByName('@OrganizationUnitID').Value=Null) or
    (spGetClerkIDBySQLServerLoginName.Parameters.
    ParamByName('@ClerkID').Value=Null) then
  begin
    spGetClerkIDBySQLServerLoginName.Close;
    raise EPrivilege.Create(Format(LoginFailed,[SQLServerName+'/'+MasterDatabase+' </'+CurrentClerkSQLServerLoginName+'/>'])+
      #13#10'Archi-Tka belps sikertelen.');
  end;

  CurrentClerkID:=
    spGetClerkIDBySQLServerLoginName.Parameters.ParamByName('@ClerkID').Value;
  CurrentOrganizationUnitID:=
    spGetClerkIDBySQLServerLoginName.Parameters.
    ParamByName('@OrganizationUnitID').Value;

  ClientRootFolder:=ExtractFilePath(ParamStr(0));
end;

procedure TdmClientMain.ReloadRegistry;
var
  IntegratedSecurity:string;
  ComputerName:Array[1..MAX_COMPUTERNAME_LENGTH + 1] of char;
  UserName:Array[1..1024] of char;
  Size:DWORD;
begin
  try
    ClientMachineReg:=TRegistry.Create;
    with ClientMachineReg do
    Begin
      RootKey:=HKEY_LOCAL_MACHINE;
      Size:=SizeOf(ComputerName);
      FillChar(ComputerName,Size,0);
      GetComputerName(@ComputerName,Size);
      WorkstationName:=Trim(String(ComputerName));

      Size:=SizeOf(UserName);
      FillChar(UserName,Size,0);
      GetUserName(@UserName,Size);
      CurrentClerkSQLServerLoginName:=String(Trim(UserName));
      CurrentClerkSQLServerLoginName:=String(Trim(UserName));

      IntegratedSecurity:='';

      if not OpenKey(sMachineSQLRootKeyName,false) then
        raise Exception.Create('Registry megnyitsa sikertelen ('+sMachineSQLRootKeyName+')');
      UseIntegratedSecurity:=ReadBool('Integrated Security');
      if UseIntegratedSecurity then
        IntegratedSecurity:='Integrated Security=SSPI;';

      SQLServerName:=ReadString('Name');
      MasterDatabase:=ReadString('Master Database Name');
      CloseKey();


      if not OpenKey(sSaperionRegClient ,false) then
        raise Exception.Create('Registry megnyitsa sikertelen ('+sMachineSQLRootKeyName+')');
      TempFilePath:=ReadString('TempDirectory');
      if (Length(TempFilePath)>0) and (TempFilePath[Length(TempFilePath)]<>'\') then
        TempFilePath:=TempFilePath+'\'; 
      CloseKey();

      ConnectionString:=
      'Provider=SQLOLEDB.1;'+
      'Persist Security Info=False;'+ IntegratedSecurity +
      'User ID='+CurrentClerkSQLServerLoginName+';'+
      'Initial Catalog='+MasterDatabase+';'+
      'Data Source='+SQLServerName+';'+
      'Use Procedure for Prepare=1;'+
      'Auto Translate=True;'+
      'Packet Size=4096;'+
      'Workstation ID='+WorkstationName+';'+
      'Use Encryption for Data=False;'+
      'Tag with column collation when possible=False';
    End;
  finally
    FreeAndNil(ClientMachineReg)
  End;
end;

procedure TdmClientMain.dsSearchAfterScroll(DataSet: TDataSet);
begin
  if frmSearchList.Visible and frmSearchList.dbgSearch.Focused then
    frmSearchList.dbgSearchEnter(frmSearchList.dbgSearch);
end;

procedure TdmClientMain.dstSearchDocumentRegisterDataAfterScroll(
  DataSet: TDataSet);
var cv:integer;
begin
  with dmClientMain.spGetDocumentTypeFields do
  Begin
    Close;
    Parameters.ParamByName('@DocumentTypeID').Value:=
      dmClientMain.dstSearchDocumentRegisterDataDocumentTypeID.Value;
    Open;
  End;

  with dmClientMain.spGetDocumentValuesByID do
  Begin
    Close;
    Parameters.ParamByName('@DocumentID').Value:=
      dmClientMain.dstSearchDocumentRegisterDataDocumentID.Value;
    Open;
  End;

  with frmClientMain.sgDynamicDatas do
  Begin
    Cols[0].Clear;
    Cols[1].Clear;
    if dmClientMain.spGetDocumentTypeFields.RecordCount=0 then
      RowCount:=2
    else
      RowCount:=dmClientMain.spGetDocumentTypeFields.RecordCount+1;
    Cells[0,0]:='Meznv';
    Cells[1,0]:='rtk';
    Row:=1;

    with dmClientMain.spGetDocumentValuesByID do
    For cv:=2 to FieldCount-1 do
    Begin
      dmClientMain.spGetDocumentTypeFields.Locate('DocumentTypeField',Fields[cv].FieldName,[]);
      Cells[0,cv-1]:=dmClientMain.spGetDocumentTypeFieldsDisplayText.AsString;
      Cells[1,cv-1]:=Fields[cv].AsString;
    End;
  End;
  frmClientMain.actArchiver.Enabled:=(DataSet.RecordCount>0); //and DataSet.FieldByName('ArchivIndex').isNull;
  frmClientMain.actViewArchive.Enabled:=not DataSet.FieldByName('ArchivIndex').isNull;
end;

end.
