unit MailsAndFaxes;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, ActnList;

type
  TfrmMailsAndFaxes = class(TForm)
    Splitter1: TSplitter;
    Panel1: TPanel;
    lvAttachs: TListView;
    reMailText: TRichEdit;
    Label1: TLabel;
    Label2: TLabel;
    Panel2: TPanel;
    lvItems: TListView;
    Label3: TLabel;
    ActionList1: TActionList;
    actRefreshMailList: TAction;
    actSaveAttachment: TAction;
    procedure lvItemsChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure actRefreshMailListExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Finbox:OleVariant;
    OutlookConnection:OleVariant;
    FNameSpace:OleVariant;
  end;

var
  frmMailsAndFaxes: TfrmMailsAndFaxes;

implementation
uses ComObj;
{$R *.DFM}

procedure TfrmMailsAndFaxes.lvItemsChange(Sender: TObject; Item: TListItem;
  Change: TItemChange);
var lvAttAchments:OleVariant;
    lvItem:OleVariant;
    cv:integer;
    lvListItem:TListItem;
begin
  if (Change=ctState) and Item.Focused and Item.Selected then
  try
    lvAttachs.Items.Clear;
    lvItem:=FNameSpace.GetItemFromID(Item.SubItems.Strings[2],Finbox.StoreID);
    lvAttAchments:=lvItem.Attachments;
    try                                                     //lvItem.SaveAs
      reMailText.Lines.Text:=lvItem.Body;
      for cv:=1 to lvAttAchments.Count do
      Begin
        lvListItem:=lvAttachs.Items.Add;
        lvListItem.Caption:=lvAttAchments.Item(cv).FileName;
      End;
    except
    end;
  except
    ShowMessage(Exception(ExceptObject).Message);
  end
end;

procedure TfrmMailsAndFaxes.actRefreshMailListExecute(Sender: TObject);
var cv:integer;
    lvItem:OleVariant;
    lvListItem:TListItem;
begin
  try
    if VarIsEmpty(OutlookConnection) or VarIsNull(OutlookConnection) then
    Begin
      OutlookConnection:=CreateOleObject('Outlook.Application');
      FNameSpace:=OutlookConnection.GetNamespace('MAPI');
      Finbox:=FNameSpace.GetDefaultFolder(6); //olFolderInbox
    End;
    lvItems.Items.Clear;
    for cv:=1 to Finbox.Items.Count do
    Begin
      lvItem:=Finbox.Items.Item(cv);
      lvListItem:=lvItems.Items.Add;
      try
        lvListItem.Caption:=lvItem.SenderName;
      except
        try
          //lvListItem.Caption:=lvItem.;
        except
        end
      end;
      lvListItem.SubItems.add(lvItem.Subject);
      try
        lvListItem.SubItems.add(lvItem.ReceivedTime);
      except
        try
          lvListItem.SubItems.add(lvItem.LastModificationTime);
        except
        end;
      end;
      lvListItem.SubItems.add(lvItem.EntryID);
    End;
  except
  end;
end;

end.
