unit SearchList;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Grids, DBGrids, ExtCtrls, ClientMain;

type
  TfrmSearchList = class(TForm)
    Panel1: TPanel;
    dbgSearch: TDBGrid;
    edtSearch: TEdit;
    btnOK: TBitBtn;
    btnCancel: TBitBtn;
    procedure edtSearchChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnOKCancelClick(Sender: TObject);
    procedure dbgSearchKeyPress(Sender: TObject; var Key: Char);
    procedure dbgSearchEnter(Sender: TObject);
    procedure edtSearchKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure dbgSearchKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure dbgSearchDblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    FLocated:Boolean;
    FDisplayField:string;
    NotInSearch:Boolean;
    FSelStart:integer;
    FSelLength:integer;
  end;

var
  frmSearchList: TfrmSearchList;

implementation

{$R *.DFM}
uses DB, SearchMain, ClientMainDataModule;

procedure TfrmSearchList.edtSearchChange(Sender: TObject);
begin
  if TWinControl(Sender).Focused and NotInSearch then
  Begin
    if dmClientMain.dsSearch.Active then
    try
      NotInSearch:=False;
      FLocated:=frmSearchMain.LocateText(Sender,FDisplayField);
      NotInSearch:=True;
    except
      FLocated:=false;
      NotInSearch:=True;
    end;
  End;
end;

procedure TfrmSearchList.FormShow(Sender: TObject);
begin
  NotInSearch:=True;
  edtSearch.SetFocus;
  edtSearch.SelStart:=FSelStart;
  edtSearch.SelLength:=FSelLength;
end;

procedure TfrmSearchList.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key=VK_RETURN) and (FLocated) then
    ModalResult:=mrOK
  else
  if (Key=VK_ESCAPE) or ((Key=VK_RETURN) and not FLocated and (edtSearch.Text='')) then
    ModalResult:=mrCancel
  else
  if (Key in [VK_DOWN,VK_UP,VK_PRIOR,VK_NEXT]) and not dbgSearch.Focused then
  Begin
    Case Key of
      VK_DOWN : dmClientMain.dsSearch.Next;
      VK_UP   : dmClientMain.dsSearch.Prior;
      VK_PRIOR :dmClientMain.dsSearch.MoveBy(-5);
      VK_NEXT  :dmClientMain.dsSearch.MoveBy(5);
    End;
    dbgSearchEnter(dbgSearch);
    FLocated:=true;
  End;
end;

procedure TfrmSearchList.btnOKCancelClick(Sender: TObject);
var key:word;
begin
  if sender=btnOK then
    key:=VK_RETURN
  else
    key:=VK_ESCAPE;
  FormKeyUp(Self,key,[]);
end;

procedure TfrmSearchList.dbgSearchKeyPress(Sender: TObject; var Key: Char);
begin
  if Key=#9 then
    edtSearch.SetFocus;
end;

procedure TfrmSearchList.dbgSearchEnter(Sender: TObject);
begin
  NotInSearch:=False;
  edtSearch.Text:=trim(dmClientMain.dsSearch.Fields.FieldByName(FDisplayField).asString);
  FLocated:=True;
  NotInSearch:=True;
  edtSearch.SelStart:=0;
  edtSearch.SelLength:=Length(edtSearch.Text);
end;

procedure TfrmSearchList.edtSearchKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key=VK_BACK then
  with Sender as TEdit do
  Begin
    if (SelStart>0) and (SelLength>0) then
    Begin
      SelStart:=SelStart-1;
      SelLength:=Length(Text)-SelStart;
    End;
  End
end;

procedure TfrmSearchList.dbgSearchKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key=VK_TAB then
    key:=0;
end;

procedure TfrmSearchList.dbgSearchDblClick(Sender: TObject);
begin
  btnOKCancelClick(btnOK);
end;

end.
